viGroupManagerXml = {};

function viGroupManagerXml:loadProfile()
	print(tostring(VehicleInspector.metadata.title).. " *GroupManager* load group profil files")
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(VehicleInspector.settingsDir);
	local file = VehicleInspector.settingsDir.. "vehicleInspectorGroupManager.xml";
	if not fileExists(file) then
		viGroupManagerXml:saveProfile();
	else
		local Xml = loadXMLFile("VehicleInspector_XML", file, "vehicleInspectorGroupManager");
		local groupNameTag = ("vehicleInspectorGroupManager.global(%d)"):format(0);
		local activeProfil = "Default";	
		local maxGroups = viGroupManager.maxGroups;
		if getXMLString(Xml, groupNameTag.."#activeProfil") ~= nil then activeProfil = getXMLString(Xml, groupNameTag.."#activeProfil");end;		
		if getXMLBool(Xml, groupNameTag.."#autoSave") ~= nil then viGroupManager.profil.autoSave = getXMLBool(Xml, groupNameTag.."#autoSave");end;
		if getXMLInt(Xml, groupNameTag.."#maxGroups") ~= nil then maxGroups = getXMLInt(Xml, groupNameTag.."#maxGroups");end;		
		if maxGroups > 20 or maxGroups < 1 then maxGroups = 10;else viGroupManager.maxGroups = maxGroups;end;		
		if viGroupManager.groups[maxGroups] == nil then viGroupManager:resetGroups();end;
		local files = Files.new(VehicleInspector.settingsDir);	
		for _, v in pairs(files.files) do
			if v.filename ~= "vehicleInspectorSettings.xml" and v.filename ~= "vehicleInspectorGroupManager.xml" then
				local isActive = false;
				if v.filename == activeProfil.. ".xml" then isActive = true;end;
				viGroupManager.groupProfile[string.gsub(v.filename, ".xml", "")] = isActive;				
			end;
		end;
		viGroupManagerXml:loadConfig(activeProfil);
		viGroupManager.profil.select = tostring(activeProfil);		
	end;
	viGroupManager.groupTyp.xmlLoaded = true;
	viGroupManager.profil.save = true;
end;

function viGroupManagerXml:saveProfile(byPlayer)
	local file = VehicleInspector.settingsDir.. "vehicleInspectorGroupManager.xml";
	local Xml = createXMLFile("VehicleInspector_XML", file, "vehicleInspectorGroupManager");
	local groupNameTag = ("vehicleInspectorGroupManager.global(%d)"):format(0);
	local activeProfil = viGroupManager:getActiveProfil();	
	--local int = 0;
	--for groupProfil, isActive in pairs(viGroupManager.groupProfile) do
	--	if isActive then 
	--		activeProfil = tostring(groupProfil);			
	--	end;
	--	local profilGroupNameTag = ("vehicleInspectorGroupManager.profil(%d)"):format(int);
	--	setXMLString(Xml, profilGroupNameTag.."#profil", tostring(groupProfil));
	--	int = int+1;
	--end;
	setXMLString(Xml, groupNameTag.."#activeProfil", activeProfil);
	setXMLBool(Xml, groupNameTag.."#autoSave", viGroupManager.profil.autoSave);
	setXMLInt(Xml, groupNameTag.."#maxGroups", viGroupManager.maxGroups);
	setXMLString(Xml, groupNameTag.."#info", "! View maxGroups Limit is 20 !");
	saveXMLFile(Xml);
	viGroupManager.profil.select = tostring(activeProfil);	
	viGroupManagerXml:saveConfig(activeProfil);
	if byPlayer ~= nil and byPlayer then
		--print(tostring(VehicleInspector.metadata.title).. " *GroupManager* save active group xml (".. tostring(activeProfil).. ") by Player")
	end;
	viGroupManager.profil.save = true;
end;

function viGroupManagerXml:loadConfig(activeProfil)
	print(tostring(VehicleInspector.metadata.title).. " *GroupManager* load active group xml (".. tostring(activeProfil).. ")")
	local file = VehicleInspector.settingsDir.. activeProfil.. ".xml";
	if not fileExists(file) then
		viGroupManagerXml:saveConfig(activeProfil);
	else
		local groupProfilXml = loadXMLFile("VehicleInspector_XML", file, "vehicleInspectorGroupManager");
		local groupNameTag = ("vehicleInspectorGroupManager.global(%d)"):format(0);
		--if getXMLBool(groupProfilXml, groupNameTag.."#isActive") ~= nil then isActive = getXMLBool(groupProfilXml, groupNameTag.."#isActive");end;
		for group=0, viGroupManager.maxGroups do
			groupNameTag = ("vehicleInspectorGroupManager.group"..tostring(group).."(%d)"):format(0);
			if groupNameTag == nil or getXMLString(groupProfilXml, groupNameTag.."#name") == nil or group > viGroupManager.maxGroups then return;end;
			if getXMLString(groupProfilXml, groupNameTag.."#name") ~= nil then
				viGroupManager.groupsName[group] = getXMLString(groupProfilXml, groupNameTag.."#name");
			end;
			if getXMLBool(groupProfilXml, groupNameTag.."#view") ~= nil then
				viGroupManager.viewGroups[group] = getXMLBool(groupProfilXml, groupNameTag.."#view");
			end;					
			local int = 0;
			while true do
				local tempGroupNameTag = (groupNameTag.. ".vehicle(%d)"):format(int);
				if tempGroupNameTag == nil or getXMLInt(groupProfilXml, tempGroupNameTag.. "#groupTyp") == nil or int > 100 then break;else
				local groupTyp = getXMLInt(groupProfilXml, tempGroupNameTag.. "#groupTyp");
				local name = "unknown";
				if getXMLString(groupProfilXml, tempGroupNameTag.. "#name") ~= nil then name = getXMLString(groupProfilXml, tempGroupNameTag.. "#name");end;
				if viGroupManager.groups[group][groupTyp] == nil then viGroupManager.groups[group][groupTyp] = {node=-1,name=tostring(name)};end; --set/refresh rootNode later
				if viGroupManager.groupTyp.onLoad[groupTyp] == nil then
					viGroupManager.groupTyp.onLoad[groupTyp] = {group={},name=name};				
				end;				
				table.insert(viGroupManager.groupTyp.onLoad[groupTyp].group, group);				
				int = int+1;
				end;
			end;
		end;
	end;
end;

function viGroupManagerXml:saveConfig(activeProfil, newProfil)
	local groupFile = VehicleInspector.settingsDir.. activeProfil.. ".xml";
	local groupProfilXml = createXMLFile("VehicleInspector_XML", groupFile, "vehicleInspectorGroupManager");
	local groupNameTag = ("vehicleInspectorGroupManager.global(%d)"):format(0);
	setXMLBool(groupProfilXml, groupNameTag.."#isActive", newProfil == nil);
	for group=0, viGroupManager.maxGroups do
		groupNameTag = ("vehicleInspectorGroupManager.group"..tostring(group).."(%d)"):format(0);
		setXMLString(groupProfilXml, groupNameTag.."#name", viGroupManager.groupsName[group]);
		if newProfil == nil then 
			setXMLBool(groupProfilXml, groupNameTag.."#view", viGroupManager.viewGroups[group]);
		else
			setXMLBool(groupProfilXml, groupNameTag.."#view", group == 0);
		end;
		if newProfil == nil then
			local int = 0;
			for groupTyp, value in pairs(viGroupManager.groups[group]) do			
				local tempGroupNameTag = (groupNameTag.. ".vehicle(%d)"):format(int);
				setXMLInt(groupProfilXml, tempGroupNameTag.."#groupTyp", groupTyp);
				setXMLString(groupProfilXml, tempGroupNameTag.."#name", value.name);
				int = int+1;
			end;
		end;
	end;
	saveXMLFile(groupProfilXml);	
end;

function viGroupManagerXml:generateNewGroupProfil(profilName, guiDialog)	
	if profilName == nil or type(profilName) ~= "string" then return;end;
	local profilXmlName = string.gsub(profilName, " ", "");
	viGroupManagerXml:saveConfig(profilXmlName, false);
	viGroupManager.groupProfile[profilXmlName] = false;
	if guiDialog ~= nil and guiDialog then g_currentMission.hl.addTextDisplay( {txt="New Group Profil created", txtBold=true, duration=3} );end;	
end;

function viGroupManagerXml:deleteGroupProfil(profilName)	
	if profilName == nil or type(profilName) ~= "string" then return;end;
	local file = VehicleInspector.settingsDir.. tostring(profilName).. ".xml";
	if fileExists(file) then 
		getfenv(0).deleteFile(file);	
		if viGroupManager.groupProfile[profilName] ~= nil then viGroupManager.groupProfile[profilName] = nil;end;
		g_currentMission.hl.addTextDisplay( {txt="Delete ".. tostring(profilName).. " Group Profil", txtBold=true, duration=3} );
	end;
end;

function viGroupManagerXml:editGroupName(groupName, guiDialog)
	if groupName == nil or type(groupName) ~= "string" then return;end;
	viGroupManager.groupsName[viGroupManager.profil.groupSelect] = tostring(groupName);
	viGroupManager.profil.save = false;
	if guiDialog ~= nil and guiDialog then g_currentMission.hl.addTextDisplay( {txt="Set New Group Name", txtBold=true, duration=3} );end;
end;
